courses/urls.py
from django.urls import path

from courses.views import (
    CourseList,
)

app_name = "courses"

urlpatterns = [
    path("", CourseList.as_view(), name="courses-list"),
]

lms/urls.py
from . import settings
from django.contrib.staticfiles.urls import static
from django.contrib import admin
from django.urls import path, include
from students.views import hello, IndexPage


urlpatterns = [
    path("", IndexPage.as_view(), name="index"),
    path("admin/", admin.site.urls),
    path("hello/", hello),
    path("students/", include("students.urls")),
    path("courses/", include("courses.urls")),
    path("teachers/", include("teachers.urls")),
    path('oauth/', include('social_django.urls'), name='social'),
]
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

if settings.DEBUG:
    import debug_toolbar

    urlpatterns = [
                      path("__debug__/", include(debug_toolbar.urls)),
                  ] + urlpatterns

students/urls.py
from django.urls import path

from students.views import (
    StudentList,
    CreateStudent,
    UpdateStudent,
    DeleteStudent,
    SearchStudents,
    LoginStudent,
    LogoutStudent,
    RegistrationStudent,
    send_email,
    ActivateUser
)

app_name = "students"

urlpatterns = [
    path("", StudentList.as_view(), name="list"),
    path("create/", CreateStudent.as_view(), name="create"),
    path("update/<int:pk>/", UpdateStudent.as_view(), name="update"),
    path("delete/<int:pk>/", DeleteStudent.as_view(), name="delete"),
    path("search-students/", SearchStudents.as_view(), name="search-students"),
    path("login/", LoginStudent.as_view(), name="login"),
    path("logout/", LogoutStudent.as_view(), name="logout"),
    path("registration/", RegistrationStudent.as_view(), name="registration"),
    path('send_email/', send_email, name='send_email'),
    path('activate/<str:uidb64>/<str:token>', ActivateUser.as_view(), name='activate')

]

teachers/urls.py
from django.urls import path

from teachers.views import (
    TeachersList,
    CreateTeacher,
)

app_name = "teachers"

urlpatterns = [
    path("", TeachersList.as_view(), name="teachers-list"),
    path("create/", CreateTeacher.as_view(), name="create-teacher"),
]

courses/models.py
import datetime
from django.db import models
import uuid


class Course(models.Model):
    id = models.UUIDField(
        primary_key=True, unique=True, max_length=16, default=uuid.uuid4, editable=False
    )
    name = models.CharField(null=False, max_length=100)
    start_date = models.DateField(null=True, default=datetime.date(2021, 10, 1))
    count_of_students = models.IntegerField(default=0)
    room = models.ForeignKey(
        "courses.Room", null=True, related_name="courses", on_delete=models.SET_NULL
    )

    def __str__(self):
        return f"{self.name}"


class Room(models.Model):
    location = models.CharField(
        max_length=100,
        null=True,
        blank=True,
    )
    color = models.ForeignKey("courses.Color", null=True, on_delete=models.SET_NULL)


class Color(models.Model):
    name = models.CharField(max_length=100, null=True, blank=True)

students/models.py
from django.contrib.auth import get_user_model
from django.contrib.auth.models import AbstractBaseUser, PermissionsMixin
from django.core.mail import send_mail
from faker import Faker
from students.managers import PeopleManager
from students.validators import (
    no_elon_validator,
    secure_email_validator,
    clean_avatar,
    file_extension,
)
from teachers.models import *
from django.db import models
import datetime
from students.managers import CustomUserManager


class CustomUser(AbstractBaseUser, PermissionsMixin):
    email = models.EmailField('email address', unique=True)
    first_name = models.CharField('first name', max_length=150, blank=True)
    last_name = models.CharField('last name', max_length=150, blank=True)
    date_joined = models.DateTimeField('date joined', auto_now_add=True)
    photo = models.ImageField(upload_to='user_photos/', null=True, blank=True)
    is_active = models.BooleanField(
        'active',
        default=True,
        help_text='Designates whether this user should be treated as active. '
                  'Unselect this instead of deleting accounts.',
    )
    is_staff = models.BooleanField(
        'staff status',
        default=False,
        help_text='Designates whether the user can log into this admin site.',
    )
    objects = CustomUserManager()
    USERNAME_FIELD = 'email'
    REQUIRED_FIELDS = []

    class Meta:
        verbose_name = 'user'
        verbose_name_plural = 'users'

    def get_full_name(self):
        """
        Return the first_name plus the last_name, with a space in between.
        """
        full_name = f'{self.first_name} {self.last_name}'
        return full_name.strip()

    def get_short_name(self):
        """Return the short name for the user."""
        return self.first_name

    def email_user(self, subject, message, from_email=None, **kwargs):
        """Send an email to this user."""
        send_mail(subject, message, from_email, [self.email], **kwargs)


class ExtendedUser(CustomUser):
    people = PeopleManager()

    class Meta:
        proxy = True
        ordering = ('first_name',)

    def some_action(self):
        print(self.username)


class Person(models.Model):
    first_name = models.CharField(
        max_length=60, null=False, validators=[MinLengthValidator(2)]
    )
    last_name = models.CharField(
        max_length=80, null=False, validators=[MinLengthValidator(2)]
    )
    email = models.EmailField(
        max_length=120,
        null=True,
        validators=[no_elon_validator, secure_email_validator],
    )
    phone_number = models.CharField(null=True, max_length=14, unique=True)

    class Meta:
        abstract = True
        verbose_name = "My student"
        verbose_name_plural = "All students"


class Student(Person):
    birthdate = models.DateField(null=True, default=datetime.date.today)
    course = models.ForeignKey(
        "courses.course", null=True, related_name="students", on_delete=models.SET_NULL
    )
    avatar = models.ImageField(
        upload_to="avatars/", null=True, blank=True, validators=[clean_avatar]
    )
    resume = models.FileField(
        upload_to="resumes/", null=True, blank=True, validators=[file_extension]
    )
    invitations = models.IntegerField(null=True, default=0)

    def __str__(self):
        return f"{self.full_name()}, {self.age()} ({self.id})"

    def full_name(self):
        return f"{self.first_name} {self.last_name}"

    def age(self):
        return datetime.datetime.now().year - self.birthdate.year

    def clean_first_name(self):
        first_name = self.cleaned_data["first_name"]

        return first_name.lower().strip().capitalize()

    def clean_last_name(self):
        last_name = self.cleaned_data["last_name"]

        return last_name.lower().strip().capitalize()

    @classmethod
    def generate_instances(cls, count):
        faker = Faker()
        for _ in range(count):
            st = cls(
                first_name=faker.first_name(),
                last_name=faker.last_name(),
                email=faker.email(),
                birthdate=faker.date_time_between(start_date="-30y", end_date="-18y"),
            )
            st.save()


class Invitations(models.Model):
    student = models.ForeignKey(
        "students.invitations", null=True, on_delete=models.CASCADE
    )
    invite_code = models.CharField(max_length=120, null=False)
    invited_email = models.EmailField(
        max_length=120,
        null=True,
        validators=[no_elon_validator, secure_email_validator],
    )


class UserProfile(Person, models.Model):
    user = models.OneToOneField(get_user_model(), on_delete=models.CASCADE)
    course = models.CharField(max_length=60, null=True)
    CHOICES = [
        (1, 'Student'),
        (2, 'Teacher'),
    ]

    def __str__(self):
        return f"{self.user.first_name}_{self.user.last_name}"

students/forms.py
from django.core.validators import ValidationError
from students.models import *
import datetime
from django.forms import ModelForm, TextInput, EmailField
from django.contrib.auth.forms import UserCreationForm


class PersonBaseForm(ModelForm):
    class Meta:
        model = Student
        fields = [
            "first_name",
            "last_name",
            "email",
            "birthdate",
            "phone_number"
        ]
        widgets = {"phone_number": TextInput(attrs={"pattern": "\d{10,14}"})}

    @staticmethod
    def normalize_name(name):
        return name.lower().strip().capitalize()

    def clean_first_name(self):
        first_name = self.cleaned_data["first_name"]

        return self.normalize_name(first_name)

    def clean_last_name(self):
        last_name = self.cleaned_data["last_name"]

        return self.normalize_name(last_name)

    def clean(self):
        cleaned_data = super().clean()

        first_name = cleaned_data["first_name"]
        last_name = cleaned_data["last_name"]

        if first_name == last_name:
            raise ValidationError(
                "Maybe you made a mistake, because your last name "
                "is equal to first name"
            )
        return cleaned_data

    def clean_birthdate(self):
        birthdate = self.cleaned_data["birthdate"]

        if datetime.datetime.now().year - self.birthdate.year < 18:
            raise ValidationError("You are too young to be our student, sorry")

        return birthdate


class StudentCreateForm(PersonBaseForm):
    class Meta(PersonBaseForm.Meta):
        fields = [
            "first_name",
            "last_name",
            "avatar",
            "email",
            "phone_number",
            "resume",
        ]


class RegistrationStudentForm(UserCreationForm):
    email = EmailField(
        max_length=200, help_text="Registration without email is not possible!"
    )

    class Meta:
        model = CustomUser
        fields = ["email", "password1", "password2"]

teachers/forms.py
from django.forms import ModelForm
from teachers.models import Teacher


class TeacherCreateForm(ModelForm):
    class Meta:
        model = Teacher
        fields = ["first_name", "last_name", "birthdate"]

courses/views.py
from django.urls import reverse_lazy
from courses.models import *
from webargs import djangoparser
from django.views.generic import ListView
from django.contrib.auth.mixins import LoginRequiredMixin


parser = djangoparser.DjangoParser()


class CourseList(LoginRequiredMixin, ListView):
    login_url = reverse_lazy("students:login")
    model = Course
    context_object_name = "courses_list"
    template_name = "courses_table.html"

students/views.py
import self as self
from django.contrib.auth import login
from django.db.models import Q
from django.urls import reverse_lazy
from django.http import HttpResponse
from django.utils.encoding import force_bytes
from django.utils.http import urlsafe_base64_decode
from django.contrib.auth.views import LoginView, LogoutView
from django.forms.utils import ErrorList
from django.contrib.auth.mixins import LoginRequiredMixin
from django.core.mail import send_mail, EmailMessage
from django.contrib import messages

from courses.models import Course
from students.forms import *
from students.models import *
from django.core.exceptions import BadRequest
from webargs import djangoparser
from django.views.generic import (
    ListView,
    TemplateView,
    CreateView,
    UpdateView,
    DeleteView, RedirectView,
)
from students.services.emails import send_registration_email
from students.token_generator import TokenGenerator

parser = djangoparser.DjangoParser()


def hello(request):
    return HttpResponse("SUCCESS")


@parser.error_handler
def handle_error(error, req, schema, *, error_status_code, error_headers):
    raise BadRequest(error.messages)


class StudentList(LoginRequiredMixin, ListView):
    login_url = reverse_lazy("students:login")
    model = Student
    template_name = "students_table.html"
    extra_context = {
        "courses_list": Course.objects.all(),
        "students_list": Student.objects.all(),
    }

    def get_queryset(self):
        query = self.request.GET.get("course_id")
        print(Student.objects.filter(course_id=query))
        if query:
            self.extra_context['students_list'] = Student.objects.filter(course_id=query)
            return Student.objects.filter(course_id=query)
        return Student.objects.all()


class SearchStudents(ListView):
    model = Student
    template_name = "students_table.html"
    context_object_name = "students_list"
    extra_context = {
        "courses_list": Course.objects.all(),
    }

    def get_queryset(self):
        query = self.request.GET.get("search")
        students_list = Student.objects.filter(
            Q(first_name__icontains=query) | Q(last_name__icontains=query)
        )
        return students_list


class UpdateStudent(LoginRequiredMixin, UpdateView):
    login_url = reverse_lazy("students:login")
    model = Student
    template_name = "students_update.html"
    fields = (
        "first_name",
        "last_name",
        "email",
        "phone_number",
        "course",
        "avatar",
        "resume",
    )
    success_url = reverse_lazy("students:list")


class DeleteStudent(LoginRequiredMixin, DeleteView):
    login_url = reverse_lazy("students:login")
    model = Student
    template_name = "students_delete.html"
    success_url = reverse_lazy("students:list")


class CreateStudent(LoginRequiredMixin, CreateView):
    login_url = reverse_lazy("students:login")
    template_name = "students_create.html"
    fields = (
        "first_name",
        "last_name",
        "email",
        "phone_number",
        "birthdate",
        "course",
        "avatar",
        "resume",
    )
    model = Student
    success_url = reverse_lazy("students:list")

    def form_valid(self, form):
        self.object = form.save(commit=False)
        first_name = form.cleaned_data["first_name"]
        last_name = form.cleaned_data["last_name"]
        if first_name == last_name:
            form._errors["first_name"] = ErrorList(
                ["First and last name can't be equal"]
            )
            form._errors["last_name"] = ErrorList(
                ["First and last name can't be equal"]
            )
            return super().form_invalid(form)
        return super().form_valid(form)


class LoginStudent(LoginView):
    success_url = reverse_lazy("index")


class LogoutStudent(LogoutView):
    template_name = "registration/logout.html"


class RegistrationStudent(CreateView):
    form_class = RegistrationStudentForm
    template_name = "registration/registration.html"
    success_url = reverse_lazy("index")

    def form_valid(self, form):
        self.object = form.save(commit=False)
        self.object.is_active = False
        self.object.save()
        send_registration_email(request=self.request,
                                user_instance=self.object)
        return super().form_valid(form)


class IndexPage(LoginRequiredMixin, TemplateView):
    template_name = "index.html"
    login_url = reverse_lazy("students:login")
    extra_context = {"courses_list": Course.objects.all()}


def send_email(request):
    email = EmailMessage(subject='Registration from LMS',
                         body="Test text",
                         to=['lms.students.hw@gmail.com'])
    email.send()
    return HttpResponse('Done')


class ActivateUser(RedirectView):
    url = reverse_lazy("students:login")

    def get(self, request, uidb64, token, *args, **kwargs):
        print(f"uidb64: {uidb64}")
        print(f"token: {token}")

        try:
            user_pk = force_bytes(urlsafe_base64_decode(uidb64))
            print(f"user_pk: {user_pk}")
            current_user = CustomUser.objects.get(pk=user_pk)
        except (CustomUser.DoesNotExist, ValueError, TypeError):
            return HttpResponse("Wrong data")

        if current_user and TokenGenerator().check_token(current_user, token):
            current_user.is_active = True
            current_user.save()

            login(request, current_user)
            return super().get(request, *args, **kwargs)
        return HttpResponse("Wrong data")

teachers/views.py
from django.views.generic import CreateView, ListView
from courses.models import Course
from students.models import *
from django.urls import reverse_lazy
from django.contrib.auth.mixins import LoginRequiredMixin


class TeachersList(LoginRequiredMixin, ListView):
    login_url = reverse_lazy("students:login")
    model = Teacher
    template_name = "teachers_table.html"
    context_object_name = "teachers_list"
    extra_context = {
        "courses_list": Course.objects.all(),
    }

    def get_queryset(self):
        query = self.request.GET.get("course")
        print(Teacher.objects.filter(course=query))
        if query:
            self.extra_context['teachers_list'] = Teacher.objects.filter(course=query)
            return Teacher.objects.filter(course=query)
        return Teacher.objects.all()


class CreateTeacher(LoginRequiredMixin, CreateView):
    login_url = reverse_lazy("students:login")
    template_name = "teacher_create.html"
    fields = "first_name", "last_name", "course"
    model = Teacher
    success_url = reverse_lazy("teachers:teachers-list")

students/templates/courses_table.html
{% extends "index.html" %}

{% block content %}
    <table class="table">
        <thead>
        <tr>
            <th scope="col">Name</th>
            <th scope="col">Start date</th>
            <th scope="col">Count of students</th>
        </tr>
        </thead>
        <tbody>
        {% for course in courses_list %}
            <tr>
                <th scope="row">{{ course.name }}</th>
                <td>{{ course.start_date }}</td>
                <td>{{ course.count_of_students }}</td>
            </tr>
        {% endfor %}

        </tbody>
    </table>
{% endblock %}

students/templates/index.html
<!doctype html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="">
    <meta name="author"
          content="Mark Otto, Jacob Thornton, and Bootstrap contributors">
    <meta name="generator" content="Hugo 0.88.1">
    <title>Fixed top navbar example · Bootstrap v5.1</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css"
          rel="stylesheet"
          integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3"
          crossorigin="anonymous">

    <link rel="canonical"
          href="https://getbootstrap.com/docs/5.1/examples/navbar-fixed/">

    <style>
        .bd-placeholder-img {
            font-size: 1.125rem;
            text-anchor: middle;
            -webkit-user-select: none;
            -moz-user-select: none;
            user-select: none;
        }

        @media (min-width: 768px) {
            .bd-placeholder-img-lg {
                font-size: 3.5rem;
            }
        }
    </style>
</head>
<body>

<nav class="navbar navbar-expand-md navbar-dark fixed-top bg-dark">
    <div class="container-fluid">
        <a class="navbar-brand" href="{% url 'index' %}">Home</a>
        <button class="navbar-toggler" type="button" data-bs-toggle="collapse"
                data-bs-target="#navbarCollapse" aria-controls="navbarCollapse"
                aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarCollapse">
            <ul class="navbar-nav me-auto mb-2 mb-md-0">
                <ul class="navbar-nav">
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="navbarDropdownMenuLink0" role="button"
                       data-bs-toggle="dropdown"  aria-expanded="false">Students</a>
                    <ul class="dropdown-menu" aria-labelledby="navbarDropdownMenuLink">
                <li><a class="dropdown-item" href="{% url 'students:list' %}">All students table</a>
                    <a class="dropdown-item" href="{% url 'students:create' %}">Create student</a>
            </ul>
        <li>
                <ul class="navbar-nav">
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="navbarDropdownMenuLink" role="button"
                       data-bs-toggle="dropdown"  aria-expanded="false">Teachers</a>
                    <ul class="dropdown-menu" aria-labelledby="navbarDropdownMenuLink">
                <li><a class="dropdown-item" href="{% url 'teachers:teachers-list' %}">All teachers</a>
                    <a class="dropdown-item" href="{% url 'teachers:create-teacher' %}">Create teacher</a>
                </ul>
                </li>
        <li>
                <ul class="navbar-nav">
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="navbarDropdownMenuLink2" role="button"
                       data-bs-toggle="dropdown"  aria-expanded="false"> Courses</a>
                    <ul class="dropdown-menu" aria-labelledby="navbarDropdownMenuLink">
                <li><a class="dropdown-item" href="{% url 'courses:courses-list' %}">All courses</a>
                    <div class="dropdown-divider"></div>

                    {% for course in courses_list %}
                    <a class="dropdown-item" href="{% url 'courses:courses-list' %}">{{ course.name }}</a>
                    {% endfor %}
                    </ul>
                </li>
                </li>
                <li>

                {% if user.is_authenticated %}
         <li class="nav-item">
         <a class="nav-link" href="{% url 'students:logout' %}"> Logout</a>
         </li>
                {% else %}


         <li class="nav-item">
                <a class="nav-link" href="{% url 'students:registration' %}"> Registration</a>
         </li>
         <li class="nav-item">
                <a class="nav-link" href="{% url 'students:login' %}"> Login</a>
         </li>
         <li class="nav-item">
                <a class="nav-link" href="{% url 'social:begin' 'facebook' %}"> Facebook login</a>
         </li>
         <li class="nav-item">
                <a class="nav-link" href="{% url 'social:begin' 'github' %}"> GitHub login</a>
         </li>
                {% endif %}
         <form class="d-flex" method="get" action="{% url 'students:search-students' %}">
                <input class="form-control me-2" type="text" name="search"
                       placeholder="Search for students..." aria-label="Search">
                <button class="btn btn-outline-success" type="submit">Search
                </button>
         </ul>
         </form>
         </li>
         </ul>
         </div>
         </nav>

<main class="container">
    <div class="bg-light p-5 rounded">
        {% block content %}
        <p></p>
        <h2>Server for working with students, teachers and their groups</h2>
        <p class="lead">Here you can create, update, delete and view all needed information</p>
        <p><img src="https://image.mel.fm/i/I/IoT9VfRJLP/590.png"</p>
        {% endblock %}
    </div>
</main>


<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p"
        crossorigin="anonymous"></script>

</body>
</html>

students/templates/students_create.html
{% extends "index.html" %}
{% load crispy_forms_tags %}
{% block content %}
<p></p>
    <form method="post">
        {% csrf_token %}
        {{ form|crispy }}
        <input class="btn btn-success" type="submit" value="Create"/>
    </form>
{% endblock %}

students/templates/students_delete.html
{% extends "index.html" %}
{% load crispy_forms_tags %}
{% block content %}
    <form
            method="post"
            enctype="multipart/form-data">
        <p></p>
        {% csrf_token %}
        {{ form|crispy }}
        <H2>Are you sure you want to delete student "{{ object.first_name }} {{ object.last_name }}"?</H2>
        <a style="font-size:30px; position:relative; width: 600px; height: 50px"; class="btn btn-light"
               href="{% url 'students:list' %}" role="button"> No<a/>
        <input style="font-size:30px"; class="btn btn-danger" type="submit" value="Yes"/>
    </form>
{% endblock %}

students/templates/students_table.html
{% extends "index.html" %}

{% block content %}
<p></p>
<form class="d-flex" method="get" action="{% url 'students:list' %}" >
    <select class="form-select" name="course_id">
    <option value="none" hidden="">Choose a course to search students</option>
        {% for course in courses_list %}
        <option value={{course.id}}>{{ course.name }}</option>
        {% endfor %}
    </select>
    <button class="btn btn-outline-success" action="submit">Search</button>
</form>
<br>
<table class="table">
    <thead>
    <tr>
        <th scope="col">Avatar</th>
        <th scope="col">First name</th>
        <th scope="col">Last name</th>
        <th scope="col">Email</th>
        <th scope="col">Phone number</th>
        <th scope="col">Birthdate</th>
        <th scope="col">Age</th>
        <th scope="col">Course</th>
        <th scope="col">Resume</th>
        <th scope="col">Invitations</th>
        <th scope="col">Update</th>
        <th scope="col">Delete</th>

    </tr>
    </thead>
    <tbody>
    {% for student in students_list %}
    <tr>
        {% if student.avatar %}
            <td><img src="{{ student.avatar.url }}" width="70" height="80">
            </td>
        {% else %}
            <td>Student without avatar</td>
        {% endif %}
        <td>{{ student.first_name }}</td>
        <td>{{ student.last_name }}</td>
        <td>{{ student.email }}</td>
        <td>{{ student.phone_number }}</td>
        <td>{{ student.birthdate }}</td>
        <td>{{ student.age }}</td>
        <td>{{ student.course }}</td>
        <td>
            {% if student.resume %}
            <a href="{{ student.resume.url }}" download>Download</a>
            {% else %}
            <p>No resume</p>
            {% endif %}
        </td>
        <td>{{ student.invitations }}</td>
        <td>
            <a type="button" class="btn btn-warning"
               href="{% url 'students:update' pk=student.id %}">Update
            </a>
        </td>
        <td>
            <a type="button" class="btn btn-danger"
               href="{% url 'students:delete' pk=student.id %}">Delete
            </a>
        </td>

    </tr>
    {% endfor %}

        </tbody>
    </table>
{% endblock %}

students/templates/students_update.html
{% extends "index.html" %}
{% load crispy_forms_tags %}
{% block content %}
    <form
            method="post"
            enctype="multipart/form-data">
        <p></p>
        {% csrf_token %}
        {{ form|crispy }}
        <input class="btn btn-success" type="submit" value="Update"/>
    </form>
{% endblock %}

students/templates/teacher_create.html
{% extends "index.html" %}
{% load crispy_forms_tags %}

{% block content %}
    <div>
            <br>
        <form method="post">
            {% csrf_token %}
            {{ form|crispy }}
            <br>
            <input class="btn btn-success" type="submit" value="Create"/>
        </form>
    </div>
{% endblock %}

students/templates/teachers_table.html
{% extends "index.html" %}

{% block content %}
<p></p>
<form class="d-flex" method="get" action="{% url 'teachers:teachers-list' %}" >
    <select class="form-select" name="course">
    <option value="none" hidden="">Choose a course to search teachers</option>
    {% for course in courses_list %}
        <option value={{course.id}}>{{ course.name }}</option>
    {% endfor %}
    </select>

    <button class="btn btn-outline-success" type="submit">Search</button>
</form>
<br>
    <table class="table">
        <thead>
        <tr>
            <th scope="col">First name</th>
            <th scope="col">Last name</th>
        </tr>
        </thead>
        <tbody>
        {% for teacher in teachers_list %}
            <tr>
                <th scope="row">{{ teacher.first_name }}</th>
                <td>{{ teacher.last_name }}</td>
            </tr>
        {% endfor %}

        </tbody>
    </table>
{% endblock %}